/*
 * Copyright (c) 2018 Mellanox Technologies LTD. ALL RIGHTS RESERVED.
 * See file LICENSE for terms.
 */

#ifndef CALCULATE_PORT_GROUPS_TASK_H
#define CALCULATE_PORT_GROUPS_TASK_H

#include <stdlib.h>

#include "thread_pool_task.h"

struct ARSWDataBaseEntry;
class ParallelPortGroupsCalculator;

class CalculatePortGroupsTreeTask : public ThreadPoolTask {

    ARSWDataBaseEntry                *m_sw_db_entry_;
    ParallelPortGroupsCalculator     *m_port_groups_calculator_;

public:
    CalculatePortGroupsTreeTask(
        ParallelPortGroupsCalculator *p_port_groups_calculator) :
        m_sw_db_entry_(),
        m_port_groups_calculator_(p_port_groups_calculator) {}

    virtual ~CalculatePortGroupsTreeTask() {}

    void Init(ARSWDataBaseEntry *p_db_entry) {
        m_sw_db_entry_ = p_db_entry;
    }

    virtual void Run();
};

#endif //CALCULATE_PORT_GROUPS_TASK_H
